# MapGIS Client for JavaScript API

Cesium MapboxGL Leaflet OpenLayers
API文档

    import VisualVariableType from '../../../base/enum/VisualVariableType'
    import { defaultValue } from '../../../util'
    import { Zondy } from '../../../base'
    import { createVisualVariable } from './index'

    /**
     * 视觉变量基类
     * @class VisualVariable
     * @moduleEX BaseModule
     * @param {Object} options 初始化参数
     * @param {String} [options.field] 视觉变量字段
     * @param {String} [options.valueExpression] 字段表达式
     * @param {String} [options.valueExpressionTitle] 字段表达式标题
     */
    class VisualVariable {
      constructor(options) {
        options = defaultValue(options, {})
        /**
         * 视觉变量默认类型
         * @member {String} VisualVariable.prototype.type
         */
        this.type = VisualVariableType.default
        /**
         * 视觉变量字段
         * @member {String} VisualVariable.prototype.field
         */
        this.field = defaultValue(options.field, '')
        /**
         * 视觉变量字段表达式
         * @member {String} VisualVariable.prototype.valueExpression
         */
        this.valueExpression = defaultValue(options.valueExpression, '')
        /**
         * 字段表达式标题
         * @member {String} VisualVariable.prototype.valueExpressionTitle
         */
        this.valueExpressionTitle = defaultValue(options.valueExpressionTitle, '')
      }

      /**
       * 通过json构造VisualVariable对象
       * @return {VisualVariable} json对象
       * */
      static fromJSON(json) {
        json = defaultValue(json, {})
        return createVisualVariable(json)
      }

      /**
       * 导出为json对象
       * @return {Object} json对象
       * */
      toJSON() {
        const json = {}
        json.field = this.field
        json.valueExpression = this.valueExpression
        json.valueExpressionTitle = this.valueExpressionTitle
        return json
      }

      /**
       * 克隆对象
       * @return {VisualVariable} 克隆后的VisualVariable对象
       */
      clone() {
        return new VisualVariable(this.toJSON())
      }
    }

    Zondy.Renderer.VisualVariable.VisualVariable = VisualVariable
    export default VisualVariable

构造函数
成员变量
方法
事件